with(LinearAlgebra);

A:= Matrix(4,4);

Ec    := (u^2 + v^2)/2;
c2    := (u^2 + v^2)/ M^2;
H     := Ec + c2/(gam-1);
#H := ((gam-1)*(1+t^2)*Ec + (u*t-v)^2) / ((gam-1)*(1+t^2)); 
tgphi := v/u;
tgbeta := 1 /sqrt(M^2-1);
t     := (tgphi + tgbeta)/(1-tgphi*tgbeta);
dy:=(tgphi + tgbeta);
dx := (1-tgphi*tgbeta);
kappa := u*t - v ;
gam1  := gam -1 ;
E := c2/ (gam*(gam-1)) + Ec ;
p := (gam-1)*rho*(E-Ec);

X := diff(((gam-1)*rho*(c/rho - a^2/(2*rho^2) - b^2/(2*rho^2) ))/rho^gam , rho);
Y := diff(((gam-1)*rho*(c/rho - a^2/(2*rho^2) - b^2/(2*rho^2) ))/rho^gam , a);
Z := diff(((gam-1)*rho*(c/rho - a^2/(2*rho^2) - b^2/(2*rho^2) ))/rho^gam , b);
T := diff(((gam-1)*rho*(c/rho - a^2/(2*rho^2) - b^2/(2*rho^2) ))/rho^gam , c);
a:= rho*u;
b:= rho*v;
c:= rho*E;


dnudM :=  sqrt(M^2-1.)/M/(1+0.5*gam1*M^2) ;
rhop := rho*p ;


drhopdrho  :=  gam1*rho*E;
drhopdrhou := -gam1*rho*u;
drhopdrhov := -gam1*rho*v;
drhopdrhoE :=  gam1*rho ;

dM2drho :=1./gam*((rho*u)^2+(rho*v)^2)*(-1./rhop^2)*drhopdrho;
dM2drhou := 2.*rho*u/gam/rhop + 1./gam*((rho*u)^2+(rho*v)^2)*(-1./rhop^2)*drhopdrhou;
dM2drhov := 2.*rho*v/gam/rhop + 1./gam*((rho*u)^2+(rho*v)^2)*(-1./rhop^2)*drhopdrhov;
dM2drhoE :=1./gam*((rho*u)^2+(rho*v)^2)*(-1./rhop^2)*drhopdrhoE;   
                                                                              
dkpdrho  :=-dnudM*(0.5/M)*dM2drho;
dkpdrhou := 1./(1.+(v/u)^2)*(-rho*v/rho^2/u^2)-dnudM*(0.5/M)*dM2drhou;
dkpdrhov := 1./(1.+(v/u)^2)*(1./rho/u)-dnudM*(0.5/M)*dM2drhov;
dkpdrhoE :=-dnudM*(0.5/M)*dM2drhoE;  



# first line :

A[1,1] := gam1*(u+t*v)*Ec; 
A[1,2] := -1*(gam*u*(t*v+u) -2*Ec);
A[1,3] := -gam*v*(t*v+u)+2*Ec*t;
A[1,4] :=  gam1*(t*v + u);


A[2,1] := (-gam*E +2*(gam-1)*Ec) ;
A[2,2] := -1*(gam-1)*u;
A[2,3] := -1*(gam-1)*v;
A[2,4] := gam;



A[3,1] := (-H +2*Ec);
A[3,2] := -u;
A[3,3] := -v;
A[3,4] := 1;

A[4,1] := simplify(dkpdrho);
A[4,2] := simplify(dkpdrhou);
A[4,3] := simplify(dkpdrhov);
A[4,4] := simplify(dkpdrhoE);





eqns := {S*A[1,1]+ Q*A[2,1]+ F*A[3,1] - A[4,1], S*A[1,2]+ Q*A[2,2]+ F*A[3,2] - A[4,2], S*A[1,3]+ Q*A[2,3]+ F*A[3,3] - A[4,3], S*A[1,4]+ Q*A[2,4]+ F*A[3,4] - A[4,4]};
vars := {S,Q,F};
soln :=solve(eqns,vars);
assign(soln);
simplify(S);
simplify(Q);
simplify(F);


simplify(S*A[1,1]+ Q*A[2,1]+ F*A[3,1] - A[4,1]);
simplify(S*A[1,2]+ Q*A[2,2]+ F*A[3,2] - A[4,2]);
simplify(S*A[1,3]+ Q*A[2,3]+ F*A[3,3] - A[4,3]);
simplify(S*A[1,4]+ Q*A[2,4]+ F*A[3,4] - A[4,4]);
Rank_of_Matrix_A = Rank(A);



d10_ro := (gam-1)*sqrt(M^2 -1)*Ec;
d10_rou := -(v +gam1*sqrt(M^2 -1)*u);
d10_rov := (u-gam1*sqrt(M^2-1)*v);
d10_roe := sqrt(M^2-1)*gam1;

simplify(A[1,1]/d10_ro);
simplify(A[1,2]/d10_rou);
simplify(A[1,3]/d10_rov);
simplify(A[1,4]/d10_roe);

simplify((u+t*v)/sqrt(M^2-1));
